<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 02/12/2004 *
 * ===================                          Last change: 02/12/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-theme_edit.php                              *
 * -------------------------------------------------------------------- *
 * Short description :                                                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  :                                                  *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('admin', __FILE__);

if (!isExtensionActive('theme')) {
	loadTemplate('admin_settings_saved', false, generateExtensionInactiveNotInstalledMessage('theme'));
	return;
} // END - if

// Check for selected themes
if (countPostSelection() > 0) {
	$OUT = '';
	foreach (postRequestElement('sel') as $id => $sel) {
		$sql = '';
		// Shall I de-/activate or delete themes?
		if (isPostRequestElementSet(('status'))) {
			// Change status
			if (postRequestElement('active', $id) == 'Y') {
				$sql = "UPDATE `{?_MYSQL_PREFIX?}_themes` SET theme_active='N' WHERE `id`='".$id."' LIMIT 1";
			} else {
				$sql = "UPDATE `{?_MYSQL_PREFIX?}_themes` SET theme_active='Y' WHERE `id`='".$id."' LIMIT 1";
			}
			$OUT = getMessage('ADMIN_THEMES_UPDATED');
		} elseif (isPostRequestElementSet('del')) {
			// Delete themes
			$sql = "DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_themes` WHERE `id`='".$id."' LIMIT 1";
			$OUT = getMessage('ADMIN_THEMES_DELETED');
		}

		// Run SQL command?
		if (!empty($sql)) {
			// Run it
			$result = SQL_QUERY($sql, __FILE__, __LINE__);

			// Rebuild cache
			rebuildCacheFile('themes', 'them');
		} // END - if
	} // END - foreach

	// Output generated?
	if (empty($OUT)) $OUT = getMessage('ADMIN_THEME_NO_OUTPUT');
} elseif (isGetRequestElementSet('default_theme')) {
	// Escape string from input
	$postData['default_theme'] = getRequestElement('default_theme');

	// Set session
	setTheme($postData['default_theme']);

	// Set it in config and current theme as well
	setConfigEntry('default_theme', $postData['default_theme']);

	// Save theme
	adminSaveSettings($postData);
}

// Init rows
$OUT = ''; 

// Switch to testing mode
$GLOBALS['theme_mode'] = 'test';

$result = SQL_QUERY("SELECT
	`id`,
	`theme_path`,
	`theme_active`,
	`theme_ver`,
	`theme_name`
FROM
	`{?_MYSQL_PREFIX?}_themes`
ORDER BY
	`theme_path` ASC", __FILE__, __LINE__);

if (SQL_NUMROWS($result) > 0) {
	// Init color
	$SW = 2;
	while ($content = SQL_FETCHARRAY($result)) {
		// Construct IFN
		$inc = sprintf("theme/%s/theme.php", $content['theme_path']);

		// Load theme in test mode
		loadInclude($inc);

		// Is the loaded theme name != current theme name?
		$LINK = $content['theme_path'];
		if ($content['theme_path'] != getCurrentTheme()) $LINK = "<a href=\"{%url=modules.php?module=admin&amp;what=theme_edit&amp;default_theme=".$content['theme_path']."%}\" title=\"{--ADMIN_SET_AS_NEW_THEME--}\">".$content['theme_path']."</a>";

		// Prepare data for the row template
		$content = array(
			'sw'        => $SW,
			'id'        => $content['id'],
			'active'    => $content['theme_active'],
			'link'      => $LINK,
			'name'      => $content['theme_name'],
			'is_act'    => translateYesNo($content['theme_active']),
			'email'     => "<a href=\"mailto:".$GLOBALS['theme_data']['email']."?Subject=[Theme:] ".$GLOBALS['theme_data']['name']." (".$content['theme_path'].")'.'\">".$GLOBALS['theme_data']['author']."</a>",
			'url_link'  => generateDerefererUrl($GLOBALS['theme_data']['url']),
			'url_title' => $GLOBALS['theme_data']['url'],
			'ver'       => $content['theme_ver'],
		);

		// Load row template and switch color
		$OUT .= loadTemplate('admin_theme_edit_row', true, $content);
		$SW = 3 - $SW;
	} // END - while

	// Free memory
	SQL_FREERESULT($result);
} else {
	// No themes found???
	$OUT .= "<tr>
  <td colspan=\"7\" class=\"bottom\" height=\"60\">
    ".loadTemplate('admin_settings_saved', true, getMessage('ADMIN_NO_THEMES_FOUND'))."
  </td>
</tr>\n";
}

// Load template
loadTemplate('admin_theme_edit', false, $OUT);

// [EOF]
?>
